\section{Algorithms and Source Code}

\subsection{Source Code and json}

\begin{lstlisting}[caption={Short code},label=lst:jsonAstNode]
"AstNode": {
      "type": "object",
      "properties": {
        "type": {
          "type": "string",
          "description": "The type of the AST node",
          "enum": [
            "root",
            "class",
            "function_declaration",
            "parameters",
            "parameter",
            "if",
            "condition",
            "then",
            "else",
            "expression",
            "statement",
            "binary_expression",
            "variable",
            "decimal",
            "float",
            "return",
            "function_call"
          ]
        },
        "name": {
          "type": "string",
          "description": "Used for the name of e.g. a function"
        },
        "value": {
          "type": "number",
          "format": "float64",
          "description": "The numeric value of a number -> needs casting"
        },
        "operator": {
          "type": "string",
          "description": "Used for the operator in a binary expression, e.g. '<'."
        },
        "startLine": {
          "type": "integer"
        },
        "endLine": {
          "type": "integer"
        },
        "startChar": {
          "type": "integer"
        },
        "endChar": {
          "type": "integer"
        },
        "children": {
          "type": "array",
          "items": {
            "$ref": "#/definitions/AstNode"
          }
        }
      }
    }
\end{lstlisting}


\subsection{Algorithms}

\begin{algorithm}[t]
\SetKwData{Left}{left}
\SetKwData{This}{this}
\SetKwData{Up}{up}
\SetKwFunction{Union}{Union}
\SetKwFunction{FindCompress}{FindCompress}

\SetKwInOut{Input}{input}
\SetKwInOut{Output}{output}

\SetKwData{HashArray}{hashArray}
\SetKwData{C}{c}
\SetKwData{D}{d}
\SetKwData{P}{p}
\SetKwData{El}{el}
\SetKwData{ChildrenOne}{children1}
\SetKwData{ChildrenTwo}{children2}
\SetKwData{DiffArray}{diffArray}
\SetKwData{SimNodesArray}{simNodesArray}
\SetKwData{TwoDimArr}{Array<Array<Tree>{}>}
\SetKwData{Array}{Array<Tree>}
\SetKwData{TreeOne}{tree1}
\SetKwData{TreeTwo}{tree2}

\SetKwFunction{CalcDiff}{calcDiff}
\SetKwFunction{SplitSimAndDiffNodes}{splitSimAndDiffNodes}
\SetKwFunction{MarkDiffRec}{markDiffRec}

\Input{Two root nodes \TreeOne and \TreeTwo to compare}
\Output{The manipulated tree nodes with diff and codeMirrorDiff attributes set for different nodes}

\BlankLine

\emph{calcDiff(\TreeOne, \TreeTwo)}:
\BlankLine
\HashArray: \TwoDimArr$\leftarrow$\{\}\;
\ChildrenOne: \Array$\leftarrow$\TreeOne.children\;
\ChildrenTwo: \Array$\leftarrow$\TreeTwo.children\;
\DiffArray: \Array$\leftarrow$\{\}\;
\BlankLine

\If(\tcp*[r]{nodes have only one child}){$|\ChildrenOne|$ = 1 AND $|\ChildrenTwo|$ = 1}{
	\If(\tcp*[r]{childs are equal}){\ChildrenOne[0].hash != \ChildrenTwo[0].hash}{
		\ChildrenOne[0].diff $\leftarrow$ true\;
		\ChildrenTwo[0].diff $\leftarrow$ true\;
		\ChildrenTwo[0].simHash = \ChildrenOne[0].hash\;
	}
	\CalcDiff{\ChildrenOne[0],\ChildrenTwo[0]}\;
}
\BlankLine
\ForEach{\C $\epsilon$ \ChildrenOne}{
	\HashArray[\C.hash] $\leftarrow$ \HashArray[\C.hash] $\cup$ \C\;
}
\ForEach{\C $\epsilon$ \ChildrenTwo}{
	\HashArray[\C.hash] $\leftarrow$ \HashArray[\C.hash] $\cup$ \C\;
}
\ForEach{\El $\epsilon$ \HashArray}{
	\If(\tcp*[r]{single node with no equal node in other tree}){$|\El|$ = 1}{
		\El[0].diff $\leftarrow$ true\;
		\DiffArray $\leftarrow$ \DiffArray $\cup$ \El[0]\;
	}\tcp*[r]{no else $\rightarrow$ nodes are equal}
}
\BlankLine
\SimNodesArray: \TwoDimArr$\leftarrow$ \SplitSimAndDiffNodes{\DiffArray}\;
\ForEach{\D $\epsilon$ \DiffArray}{
	\MarkDiffRec{\D}\;
	\D.codeMirrorDiff$\leftarrow$ true\;
}
\ForEach{\P $\epsilon$ \SimNodesArray}{
	\P[1].simHash $\leftarrow$ \P[0].hash\;
	\CalcDiff{\P[0],\P[1]}\;
}
\caption{calcDiff Algorithm}\label{alg:calcDiff}
\end{algorithm}

\begin{algorithm}[t]

\SetKwInOut{Input}{input}
\SetKwInOut{Output}{output}

\SetKwData{Array}{Array<Tree>}
\SetKwData{DiffArray}{diffArray}
\SetKwData{TwoDimArr}{Array<Array<Tree>{}>}
\SetKwData{SimNodesArray}{simNodesArray}
\SetKwData{C}{c}
\SetKwData{D}{d}
\SetKwData{CTwo}{c2}
\SetKwData{DTwo}{d2}

\Input{The \DiffArray with possible similar nodes}
\Output{The manipulated \DiffArray and a new \SimNodesArray which contains the similar nodes from the \DiffArray}

\BlankLine

\emph{splitSimAndDiffNodes(\DiffArray)}:
\BlankLine
\SimNodesArray: \TwoDimArr$\leftarrow$\{\}\;
\BlankLine
\ForEach{\D $\epsilon$ \DiffArray}{
	\ForEach{\C $\epsilon$ \D.children}{
		\ForEach{\DTwo $\epsilon$ \DiffArray \textbackslash $\left\{ \D \right\}$ }{
			\ForEach{\CTwo $\epsilon$ \DTwo.children}{
				\If{\C.hash = \CTwo.hash}{
					\SimNodesArray[$|\SimNodesArray|$] $\leftarrow$ \SimNodesArray[$|\SimNodesArray|$] $\cup$ \D\;
					\SimNodesArray[$|\SimNodesArray|$] $\leftarrow$ \SimNodesArray[$|\SimNodesArray|$] $\cup$ \DTwo\;
					\DiffArray $\leftarrow$ \DiffArray \textbackslash $\left\{ \D \right\}$\;
					\DiffArray $\leftarrow$ \DiffArray \textbackslash $\left\{ \DTwo \right\}$\;
					\Return \SimNodesArray\;
				}
			}
		}
	}
}
\Return \SimNodesArray\;
\caption{splitSimAndDiffNodes Algorithm}\label{alg:splitSimAndDiffNodes}
\end{algorithm}

\begin{algorithm}[t]
\SetKwInOut{Input}{input}
\SetKwInOut{Output}{output}

\SetKwData{Node}{node}
\SetKwData{C}{c}
\SetKwFunction{MarkDiffRec}{markDiffRec}

\Input{The root \Node for difference marking}
\Output{The manipulated \Node with diff attributes set to true}

\BlankLine

\emph{markDiffRec(\Node)}:
\BlankLine
\Node.diff $\leftarrow$ true\;
\ForEach{\C $\epsilon$ \Node.children}{
	\MarkDiffRec{\C}\;
}

\caption{markDiffRec Algorithm}\label{alg:markDiffRec}
\end{algorithm}